<!doctype html>
<html>

	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Introduction to git</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement('link');
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName('head')[0].appendChild(link);
		</script>
	</head>

	<body>
        <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>
        <div class="reveal">
            <div class="slides">
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h1>Introduction to Git</h1>
					</section>
					<section>
						<h2>Summary</h2>
						<ul>
							<li><b>What is Version Control?</b></li>
							<li><b>What is <em>Git</em> good for?</b></li>
							<li><b>How do I <em>get</em> Git?</b></li>
							<li><b>How do I <em>Git</em>?</b></li>
							<li><b>How do I Git better?</b></li>
						</ul>
					</section>
					<section>
                        <h1>Objectives</h1>
                        <a href="../objectives.html" target="_blank">Introduction to Git Objectives</a>
                    </section>				
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2>What is Version Control?</h2>
						<ul>
							<li>Manages changes to an application</li>
							<li>Allows for teams to look at the history of project easily</li>
							<li>Easier to revert a project if errors are introduced</li>
							<li>Facilitates collaboration between team members</li>
						</ul>
					</section>
					<section>
						<h2>There are many different version control tools</h2>
						<ul>
							<li>Concurrent Versions System (CVS)</li>
							<li>Subversion (SVN)</li>
							<li><em>Git</em></li>
							<li>Mercurial</li>
							<li>Bazaar</li>
						</ul>
					</section>
					<section>
						<p style="font-size:160%;" >We will be using <em><b>Git</b></em></p>
						<img height="342" src="../assets/Linus_Torvalds_talking.jpeg" alt="Linus Torvalds - Creator of git">
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2>Benefits of Version Control</h2>
						<ul>
							<li>Often, a project will have multiple teams/people working on it</li>
							<li>Very likely that not all team members will be in the same location</li>
							<li>Need a useable way to track changes across the different groups</li>
							<li>If mistakes are made, need a way to easily roll the changes back</li>
						</ul>
					</section>
					<section>
						<h4>History Graph of a Version Controlled Project</h4>
						<img height=400 src="../assets/project_viz.png" alt="version control illustration">
					</section>
					<section>
						<h4>An Basic Overview of Version Control Workflow</h4>
						<img height=400 src="../assets/28.png" alt="basic git flow">
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2>How do we use version control?</h2>
						<h3>i.e. how do we use git?</h3>
						<p>The basics:</p>
						<pre><code data-trim data-noescape>
							git clone &lt;name of repository&gt;
							git checkout &lt;branch&gt;
							git add &lt;the file(s) you changed&gt;
							git commit -m "commit message"
							git push
						</code></pre>
					</section>
					<section>
					<img src="../assets/gitfire.png" alt="In case of fire: git commit">
					</section>
					<section>
						<h2>Other Important <em>Git</em> Terms</h2>
						<ul>
							<li>Stage </li>
							<li>Branch</li>
							<li>Main branch</li>
							<li>Forking</li>
							<li>git pull / git fetch </li>
						</ul>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h1>Installing git</h1>
						<ul>
							<li>Linux - sudo apt install git </li>
							<li>Windows - git-scm.com/download/win</li>
						</ul>
					</section>
					<section>
						<h1>Configuring git globally on your computer</h1>
						<pre><code data-trim data-noescape>
							git config --global user.name "Steve Rogers"
							git config --global user.email "cap@shield.gov"
						</code></pre>
					</section>
					<section>
						<h1>Create a gitlab account with gitlab.com</h1>
						<ul>
							<li>Click register (top right) </li>
							<li>Register as you like </li>
							<li><b><i>Be aware others will see your gitlab username</i></b></li>
						</ul>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h1 style="font-size:90%;">Cloning an Existing <em>Git</em> Repository</h1>
						<ol>
							<li>Go to https://gitlab.com/39iosdev/ccd-iqt/idf/introduction-to-git</li>
							<img height="342" src="../assets/goto39iosgit.png" alt="39 IOS Intro to Git repo">
							
						</ol>
					</section>
					<section>
						<ol start="2">
							<li>Press the <b>clone</b> button</li>
							<li>Copy the url</li>
							<li>On your computer, type:<br> 
								<pre><code data-trim data-noescape>
									git clone https://gitlab.com/39iosdev/ccd-iqt/idf/introduction-to-git.git
								</code></pre>
							</li>
							<li>Type <code>ls</code> or <code>dir</code></li>
						</ol>
					</section>
					<section>
						<h2>Creating a New Repository</span></h2>
						<ul>
							<li>Using the GUI</li>
							<li>Using the CLI </li>
							<i>They are basically the same.</i>
						</ul>
					</section>
					<section>
						<h4>Using the GUI</h4>
						<ul>
							<li>Click on "New project" <img src="../assets/gui_newgitproject.png" alt="Click on new project"></li>
							<li>Name your project <img src="../assets/gui_newgitproject2.png" alt="Fill in the fields as you like"></li>			
						</ul>
					</section>
					<section>
						<h4>Using the CLI</h4>
						<p> Basically, the same as the GUI</p>
						<ul>
							<li>Go to the directory you intend to use</li>
							<li><code>git init</code> </li>
							<li>Make/edit files</li>	
						</ul>
						<pre><code data-trim data-noescape>
							git add &lt;those files&gt;
							git commit -m "&lt;motd&gt;"
							git push
						</code></pre>
					</section>
					<section>
						<h1>Success looks like:</h1>
						<img src="../assets/gitcreatesuccess.png" alt="Successful creation of git repo"></li>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section> 
						<h1>Understanding git</h1>
						<img src="../assets/understandgitmeme.jpg" alt="understand git meme">
					</section>
					<section>
						<h2>Discerning <em>Git</em></h2>
						<ul>
							<li><code>git status</code></li>
							<li><img src="../assets/gitstatusmaster.png" alt="git status of master"></li>
							<li><img src="../assets/gitstatusbranch.png" alt="git status of working branch"></li>
						</ul>
					</section>
					<section>
						<h2>Main and branches</h2>
						<h3>TL;DR Don't push to main</h3>
						<img src="../assets/pushtomasterbranch.jpg" alt="TL;DR don't push to main branch meme">
					</section>
					<section>
						<h2 style="font-size:90%;" >Using git is about working well with others</h2>
						<p>Why <code> git pull </code> and <code>git checkout</code> are really important!</p>
						<a href=""><img src="../assets/gitpath.png" alt="git path diagram"></a>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2 style="font-size:110%;" >Steps to using gitlab with your team:</h2>
						<ul>
							<li>Create an issue</li>
							<li>Create a merge request</li>
							<li><code>git clone</code> the repository</li>
							<li><code>git branch</code> the branch created by the merge request</li>
							<li><code>git pull </code> so that you have the latest version of the project</li>
					</section>
					<section>
						<h2 style="font-size:90%;">Continuing to work with your team:</h2>
						<ul>
							<li><code> git checkout -b  </code> create a branch to be merged later</li>
							<li>Make your changes</li>
							<li><code>git add </code> those changes </li>
							<li><code>got commit -m "explain what you did"</code></li>
							<li><code>git push </code></li>
							<li>Watch the progress monitor</li>
						</ul>
					</section>
					<section>
						<h2>Creating an issue</h2>
						<img height=400 src="../assets/createanissue1.png" alt="Create an issue in gitlab">
						<img src="../assets/createanissue2.png" alt="Create an issue in gitlab">
					</section>
					<section>
						<img height=600 src="../assets/createanissue3.png" alt="Create an issue in gitlab">
					</section>
					<section>
						<h2>Creating a merge request</h2>
						<img height=240 src="../assets/createamergerequest1.png" alt="Create a merge request in gitlab">
						<img height=240 src="../assets/createamergerequest2.png" alt="Create a merge request in gitlab">
					</section>
					<section>
						<h2>Cloning the repository</h2>
						<img src="../assets/goto39iosgit.png" alt="Get the merge request link and clone">
					</section>
					<section>
						<h2>Checkout your branch</h2>
						<img src="../assets/checkoutgit.png" alt="Checkout your branch">
					</section>
					<section>
						<h2>The git flow</h2>
						<ul>
							<li>git clone 'link_to_repo' </li>
							<li>git pull </li>
							<li>git checkout -b 'name_of_the_branch'</li>
							<li>git add *</li>
							<li>git commit -m "motd"</li>
							<li>git push </li>
						</ul>
					</section>
					<section>
						<h2>Watch the pipeline for your success</h2>
						<ul>
							<li>Request content to be merged</li>
							<li>Watch your success in the CI/CD pipeline</li>
						</ul>
						<img src="../assets/watchpipeline.png" alt="The CI/CD pipeline in gitlab">
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2 style="font-size:110%;" >Additional commands, when working with branches in <em>Git</em></h2> 
					</section>
					<section>
						<h2><code>git diff</code></h2>
						<img src="../assets/gitdiff.png" alt="git diff">
					</section>
					<section>
						<pre><code data-trim data-noescape>
							git rm
							git mv
							git difftool
							git reset
							git clean
						</code></pre>
						<p>See also <a href="https://git-scm.com/book/en/v2/Appendix-C%3A-Git-Commands-Basic-Snapshotting">basic git snapshotting</a></p>
					</section>
				</section>
				<!--CI/CD Slides-->
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2>CI/CD Pipelines</h2>
						<ul>
							<li>By default, Gitlab includes a robust feature called CI/CD, 
								Continuous Integration/(Continuous Delivery or Continuous Deployment)</li>
							<li>The idea behind this is, as you build more code, when you are ready to
								merge the changes, you have a pipeline of scripts to build, test, and validate
								code changes, before the changes are merged into the codebase (CI)
							</li>
							<li>Once the changes pass validation, the application is then immediately redeployed (CD)</li>
						</ul>
					</section>
					<section>
						<h2>Gitlab CI/CD Area</h2>
						<img src="../assets/cicd.png" alt="gitlab CI/CD section">
					</section>
					<section>
						<h2>YAML Configuration Files</h2>
						<ul>
							<li>Yaml Ain't Markup Language</li>
							<li>Used by Gitlab to store configuration options for pipelines</li>
							<li>In order to build pipelines for our repository, we first need to add 
								.gitlab-ci.yml file in the root of the repository
							</li>
							<img src="../assets/newyaml.png" alt="YAML template">
						</ul>
					</section>
					<section>
						<h2>Pipelines</h2>
						<ul>
							<li>After the configuration yaml file has been built, you can associate specifc 
								tasks to with a stage in the testing
							</li>
							<li>These sets of tasks are called pipelines and pipelines are commonly split into 4 stages:
							</li>
							<ul>
								<li>Build</li>
								<li>Test</li>
								<li>Staging</li>
								<li>Production</li>
							</ul>
						</ul>
					</section>
					<section>
						<h2>Jobs</h2>
						<ul>
							<li>The tasks that the pipelines run/perform are called Jobs</li>
							<li>Typically, they are related to running specific scripts, services, etc.</li>
							<li>A nice feature of Jobs is the ability to create artifacts once they complete</li>
						</ul>
					</section>
					<section>
						<h2>Artifacts</h2>
						<ul>
							<li>Once a job is finished, files and directories can possibly be created</li>
							<li>These are artifacts that the job generated</li>
							<li>A good example is a report based the performance of the pipelines</li>
							<li>All of these components of CI/CD have a lot more depth in how they can be used</li>
							<li>The field of DevOps is vast, this is just a brief taste</li>
						</ul>
					</section>
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<section>
						<h2>Questions?</h2>
					</section>
					<section>
						<h2>Summary</h2>
						<ul>
							<li>What is <em>Git</em>? i.e. What is Version Control?</li>
							<li>Why would we use <em>Git</em>?</li>
							<li>How do we use <em>Git</em>?</li>
							<li>Advanced <em>Git</em> commands</li>
						</ul>
					</section>
				</section>
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	

		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
